diff --git a/xmppserver/src/main/java/org/jivesoftware/openfire/SessionManager.java b/xmppserver/src/main/java/org/jivesoftware/openfire/SessionManager.java
index 79a2c34b3..b69f2ba33 100644
--- a/xmppserver/src/main/java/org/jivesoftware/openfire/SessionManager.java
+++ b/xmppserver/src/main/java/org/jivesoftware/openfire/SessionManager.java
@@ -691,11 +691,12 @@ public class SessionManager extends BasicModule implements ClusterEventListener
      *
      * @param session the session that was authenticated.
      */
-    public void addSession(LocalClientSession session) {
+    public void addSession(LocalClientSession session, JID previousAddress) {
         // Add session to the routing table (routing table will know session is not available yet)
         routingTable.addClientRoute(session.getAddress(), session);
         // Remove the pre-Authenticated session but remember to use the temporary ID as the key
-        localSessionManager.getPreAuthenticatedSessions().remove(session.getStreamID().toString());
+        localSessionManager.getPreAuthenticatedSessions().remove(previousAddress.getResource());
+
         SessionEventDispatcher.EventType event = session.getAuthToken().isAnonymous() ?
                 SessionEventDispatcher.EventType.anonymous_session_created :
                 SessionEventDispatcher.EventType.session_created;
diff --git a/xmppserver/src/main/java/org/jivesoftware/openfire/session/LocalClientSession.java b/xmppserver/src/main/java/org/jivesoftware/openfire/session/LocalClientSession.java
index c977d26e1..f4c279a78 100644
--- a/xmppserver/src/main/java/org/jivesoftware/openfire/session/LocalClientSession.java
+++ b/xmppserver/src/main/java/org/jivesoftware/openfire/session/LocalClientSession.java
@@ -579,6 +579,7 @@ public class LocalClientSession extends LocalSession implements ClientSession {
         } else {
             jid = new JID(auth.getUsername(), getServerName(), resource);
         }
+        final JID previousAddress = getAddress();
         setAddress(jid);
         authToken = auth;
         setStatus(Session.Status.AUTHENTICATED);
@@ -588,7 +589,7 @@ public class LocalClientSession extends LocalSession implements ClientSession {
             setDefaultList( PrivacyListManager.getInstance().getDefaultPrivacyList( auth.getUsername() ) );
         }
         // Add session to the session manager. The session will be added to the routing table as well
-        sessionManager.addSession(this);
+        sessionManager.addSession(this, previousAddress);
     }
 
     @Override
@@ -607,11 +608,12 @@ public class LocalClientSession extends LocalSession implements ClientSession {
     public void setAnonymousAuth() {
         // Anonymous users have a full JID. Use the random resource as the JID's node
         String resource = getAddress().getResource();
+        final JID previousAddress = getAddress();
         setAddress(new JID(resource, getServerName(), resource, true));
         setStatus(Session.Status.AUTHENTICATED);
         authToken = AuthToken.generateAnonymousToken();
         // Add session to the session manager. The session will be added to the routing table as well
-        sessionManager.addSession(this);
+        sessionManager.addSession(this, previousAddress);
     }
 
     /**
